#ifndef MWINDOWS_H
#define MWINDOWS_H

#include <QStackedWidget>
#include <topcore/topclassabs.h>
#include <topcore/topclasshelper.h>
#include <tdatabaseutil/tsqlselectorv2.h>
#include <QSystemTrayIcon>
#include <QLineEdit>
#include <QSplitter>
#include <QPushButton>

class QHBoxLayout;
class QLabel;
class QPropertyAnimation;
class QStackedWidget;
class QTabBar;
class QDateTime;
class QVBoxLayout;
class TFramelessWindowBar;
class TPanelMenu;
class TopMessageController;
class TopQuickToolBar;
class TopQuickButton;
class TToolButton;
class TSplitter;

class StackedWidget : public QStackedWidget {
    Q_OBJECT
public:
    StackedWidget(QWidget *iParent = nullptr);
    void setBackground(const QString &iBackground);
protected:
    void paintEvent(QPaintEvent *iEvent);
private:
    QString mBackground;
};


class SysMainWindow:public TopClassAbs
{
    Q_OBJECT

public:
    explicit SysMainWindow(const QString &iModuleNameStr = QString(""),
                           const QVariantMap &iUrlPars = QVariantMap(),
                           QWidget *iParent = nullptr);
    ~SysMainWindow();

public slots:
    void openModule(const QString &iUrl, const QVariant &iConfig);
private:
    QMap<QString, QWidget *> mUrlAddressWidgetMap;   // urlAddress:QWidget
    QMap<QString, QVariantMap> mUrlAddressConfigMap;
    QHBoxLayout *Hboxlayout;
    QLineEdit Title;
    QLabel *mMessageLabel = nullptr;
    StackedWidget *mStackedWidget = nullptr;
    QSplitter *mBodySplitter = nullptr;
    QSplitter *mMgtSplitter = nullptr;
    QWidget *mBodyWgt;

    void initMainWidget();
};


#endif
